#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 3000;

int a[MAXN + 1];
long long comb[MAXN + 1][MAXN + 1];
int n, m;

int countFlowers(int L, int R)
{
    int cnt = 0;

    for (int i = 1; i <= n; i++)
        if (a[i] >= L && a[i] <= R)
            cnt++;

    return cnt;
}

int solve(int L, int R, long long K)
{
    int cnt = countFlowers(L, R);
    if (cnt == 0) return -1;

    for (int i = 1; i <= cnt; i++)
        if (comb[cnt][i] >= K)
            return i;

    return -1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    comb[1][0] = comb[1][1] = 1;
    for (int i = 2; i <= n; i++)
        for (int j = 0; j <= i; j++)
            comb[i][j] = comb[i-1][j-1] + comb[i-1][j];

    for (int i = 1; i <= m; i++)
    {
        int L, R;
        long long K;
        cin >> L >> R >> K;

        cout << solve(L, R, K) << endl;
    }

    return 0;
}
